// OLED and PORT defines for MK4 PCB

/*------------ Port Allocation ----------
RA0 AN0 Aft Sensor             RB0  N/C
RA1 AN1 Fwd Sensor             RB1  DO OLED D_C
RA2 AN2 Light Sensor           RB2  DO OLED SDIN (FIXED)
RA3 DO Buzzer                  RB3  DO OLED RST
RA4 DO LED                     RB4  DO OLED CLK  (FIXED)
RA5 DO ICSP MCLR               RB5  DO WS0Vf FWD FET1
RA6 N/C                        RB6  DI SW FWD SWf (ICSP PGC)
RA7 DO WS0Va AFT FET2          RB7  DI SW AFT SWa (ICSP PGD)
-----------------------------------------*/

#define DisplayD_C   LATB.F1          // RB0 OLED D/C (A0)
#define DisplaySDI   LATB.F2          // RB2 OLED SDIN (FIXED)
#define DisplayRST   LATB.F3          // OLED RST
#define DisplayCLK   LATB.F4          // RB4 OLED CLK (FIXED)

// #define DisplayCE    LATB . F3          // RB3 OLED CS  NOT USED


// #define sWidth 128     // (or 128, 132?)

#define FETf       LATB.F5          // RB5 FWD FET to ground fwd sensor WS0Vf
#define FETa       LATA.F7          // RA7 AFT FET to ground aft sensor WS0Va
#define WaterAft   0                // RA0 AFT sensor ADC 0 for Aft Water sensor
#define WaterFwd   1                // RA1 FWD sensor ADC 1 for Fwd Water sensor
#define LightSens  2                // RA2 light sensor ADC 2
#define LED        LATA.F4          // RA4 LED1 test LED, 1 to activate
#define Sounder    LATA.F3          // RA3 Buzzer











// NOTE ALSO: ADC and other ports changed in MK4 board