// Header file for DIGITAL Water GAUGE
// Version 4.0 by Nigel Mercier

#include "typedefs.h"

// Global Constants
const byte SizeAft ;    // number of steps AFT sensor
const byte SensorAft[] ;
const byte LitresAft[]  ;
//const byte MaxFwd ;
const byte SizeFwd ;    // number of steps FWD sensor
const byte SensorFwd[] ;
const byte LitresFwd[] ;

// Global variables (temporary)
extern char txt4[4], txt7[7] ; // temporary for conversion strings and
extern byte i, j ;             // misc loops
// Global variables
extern int rawADC ;
extern byte adc8 ;     // 8-bit value from ADC
extern byte index ;    // index of closest value in SensorAft or SensorFwd
extern byte litVal ;   // litre value of index in LitresAft[] or LitresFwd[]
extern byte barG ;     // fraction of tank level over last array entry
extern byte mode ;     // copy of swMode at entry

// variables set in ISR and update
extern byte swMode ;   // mode of switch 0, 1 or 2
extern byte timeSec ;  // second counter
extern byte errFlag ;  // flag error for out of range reading

// Function Prototypes
signed int absVal(signed int) ; // simulate abs()
void modeF(void) ;
void modeA(void) ;
byte getADC(byte x) ;    // read ADC(x) return 8-b from 10-b
byte findNearA (byte) ;  // locate index of val, or nearby index in SensorAft
byte findNearF (byte) ;  // locate index of val, or nearby index in SensorFwd
void configInt(void);    // Configure interrupts
void beep(void) ;        // beep sounder for 50 milliseconds
void displayLarge(int) ; // display in 4 line font
